// Allow only capital outflows.  No capital inflows

// Endogenous variables.

var cy co h k ko i d bs bp bfd bfl y ys yp hs hp ks kp bg
w rk qk  r rs rp rf ps pp wealth utility tfp;


// Shock innovations
//varexo ;

parameters DELTA PSIH ETA BETA ALPHA THETAS THETAP AS AP RSTAR OMEGAK TAU SIGMA THETAY PHI GAMMA TAUL TAUD PHIB BYBAR; 

DELTA = 1-0.9^10;
ETA = 2;
BETA = 0.96^10;% imply annualized domestic interest rate = 0.04
ALPHA = 0.5;
THETAS = 1;
THETAP =1;
AS  = 1;
AP = 1.42;
RSTAR = 1.05^10;
SIGMA  =3 ;

OMEGAK = 5;


PSIH = 38;

THETAY = 1;

TAU =     0.75;


PHI    = 0.5;
GAMMA  = 0.5;
TAUD     = 0.01;
TAUL     = 1;

PHIB  = 3*10;
BYBAR = 0.04;

model;
utility = log(cy)  - PSIH*h^(ETA+1)/(1+ETA) + log(co)  + BETA*utility(+1);

// Household sector
//y - c - i + (rf(-1) -1)*bf(-1) = bf - bf(-1);

cy + d + bfd + qk*ko + i + OMEGAK/2*(i/ko - steady_state(i)/steady_state(ko))^2*ko = w * h + wealth * TAU + THETAY*(TAUL(-1)*rp(-1)*bfl(-1) + TAUD(-1)*rf(-1)*bfd(-1));

co = wealth * (1-TAU);

wealth = r(-1)*d(-1) + (1-TAUD(-1))*rf(-1)*bfd(-1) + (qk*(1-DELTA) + rk)*(ko(-1) + i(-1)) + (1-THETAY)*(TAUL(-1)*rp(-1)*bfl(-1) + TAUD(-1)*rf(-1)*bfd(-1));

w = PSIH*h^ETA *cy;

1 = BETA * cy/co(+1)*r;

r = (1-TAUD)*rf;

qk + OMEGAK/2*(i/ko - steady_state(i)/steady_state(ko))^2 - OMEGAK*(i/ko - steady_state(i)/steady_state(ko))*i/ko = BETA* cy/co(+1)*(qk(+1)*(1-DELTA)+rk(+1));

1 + OMEGAK*(i/ko - steady_state(i)/steady_state(ko)) = BETA* cy/co(+1)*(qk(+1)*(1-DELTA)+rk(+1));

k = ko + i;

ko = (1-DELTA)*k(-1);



// Consumption goods

y = (PHI*ys^((SIGMA - 1)/SIGMA) + (1-PHI)*yp^((SIGMA - 1)/SIGMA))^(SIGMA/(SIGMA - 1));

//y = ys^PHI*yp^(1-PHI);


ys*ps^SIGMA = PHI^SIGMA*y;

yp*pp^SIGMA = (1-PHI)^SIGMA*y;

//Intermediate goods

ys = AS*(ks)^(1-ALPHA)*(hs)^ALPHA;

bs + bg = THETAS*(w*hs + rk*ks);

w*hs*(1-THETAS+rs*THETAS) = ALPHA*ys*ps;

rk*ks*(1-THETAS+rs*THETAS) = (1-ALPHA)*ys*ps;

yp = AP*(kp)^(1-ALPHA)*(hp)^ALPHA;

bp = THETAP*(w*hp + rk*kp);

w*hp*(1-THETAP+rp*THETAP) = ALPHA*yp*pp;

rk*kp*(1-THETAP+rp*THETAP) = (1-ALPHA)*yp*pp;


// Banks

bg = GAMMA*d;

//rp*(1-TAUL) = rf*exp(PHIB*(bfl/y-BYBAR));
bfl = 0;

d + bfl = bg + bs + bp;

r = 1*GAMMA+rp*(1-GAMMA);

rs = (1*bg + rp*bs)/(bg + bs);

h = hs + hp;

k(-1) = ks + kp;

rf = RSTAR;

tfp = y/(k(-1))^(1-ALPHA)/(h)^ALPHA;

end;



steady_state_model;
[cy,co,h,k,ko,i,d,bs,bp,bfl,bfd,y,ys,yp,hs,hp,ks,kp,w,rk,qk,r,rs,rp,rf,ps,pp,wealth,bg]= solvess_outflow(DELTA,PSIH,ETA,BETA,ALPHA,THETAS,THETAP,AS,AP,RSTAR,PHI,GAMMA,TAUL,TAUD,TAU,SIGMA,THETAY,PHIB,BYBAR);
utility = (log(cy)  - PSIH*h^(ETA+1)/(1+ETA) + log(co))/(1-BETA);
tfp = y/(k)^(1-ALPHA)/(h)^ALPHA;

end;
steady;
check;

